<html>
<head>
<title>OgreOverlayElementFactory.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreOverlayElementFactory.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreOverlayElementFactory_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OverlayElementFactory_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OverlayElementFactory_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreOverlayElement_8h.html">OgreOverlayElement.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePanelOverlayElement_8h.html">OgrePanelOverlayElement.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreBorderPanelOverlayElement_8h.html">OgreBorderPanelOverlayElement.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreTextAreaOverlayElement_8h.html">OgreTextAreaOverlayElement.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00057"></a><a class="code" href="classOgre_1_1OverlayElementFactory.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1OverlayElementFactory.html" title="Defines the interface which all components wishing to supply OverlayElement subclasses must implement...">OverlayElementFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">OverlayAlloc</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00061"></a><a class="code" href="classOgre_1_1OverlayElementFactory.html#a1f58e18cf969c8ebbf5a40df93e744f0">00061</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OverlayElementFactory.html#a1f58e18cf969c8ebbf5a40df93e744f0" title="Destroy the overlay element factory.">~OverlayElementFactory</a> () {}
<a name="l00063"></a>00063         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* createOverlayElement(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName) = 0;
<a name="l00065"></a><a class="code" href="classOgre_1_1OverlayElementFactory.html#a72387fe84a4dc4e87d7ab1cfeaaf73b6">00065</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OverlayElementFactory.html#a72387fe84a4dc4e87d7ab1cfeaaf73b6" title="Destroys a OverlayElement which this factory created previously.">destroyOverlayElement</a>(<a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* pElement) { <span class="keyword">delete</span> pElement; }
<a name="l00067"></a>00067         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTypeName(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00068"></a>00068     };
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00072"></a><a class="code" href="classOgre_1_1PanelOverlayElementFactory.html">00072</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PanelOverlayElementFactory.html" title="Factory for creating PanelOverlayElement instances.">PanelOverlayElementFactory</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1OverlayElementFactory.html" title="Defines the interface which all components wishing to supply OverlayElement subclasses must implement...">OverlayElementFactory</a>
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074     <span class="keyword">public</span>:
<a name="l00076"></a><a class="code" href="classOgre_1_1PanelOverlayElementFactory.html#ac871ad00836156935e4a63c228b14f20">00076</a>         <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* createOverlayElement(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName)
<a name="l00077"></a>00077         {
<a name="l00078"></a>00078             <span class="keywordflow">return</span> <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1PanelOverlayElement.html" title="OverlayElement representing a flat, single-material (or transparent) panel which can contain other el...">PanelOverlayElement</a>(instanceName);
<a name="l00079"></a>00079         }
<a name="l00081"></a>00081         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTypeName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00082"></a>00082     };
<a name="l00083"></a>00083 
<a name="l00085"></a><a class="code" href="classOgre_1_1BorderPanelOverlayElementFactory.html">00085</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1BorderPanelOverlayElementFactory.html" title="Factory for creating BorderPanelOverlayElement instances.">BorderPanelOverlayElementFactory</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1OverlayElementFactory.html" title="Defines the interface which all components wishing to supply OverlayElement subclasses must implement...">OverlayElementFactory</a>
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00089"></a><a class="code" href="classOgre_1_1BorderPanelOverlayElementFactory.html#a16968c41d48927f521a6d1365c6bd338">00089</a>         <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* createOverlayElement(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName)
<a name="l00090"></a>00090         {
<a name="l00091"></a>00091             <span class="keywordflow">return</span> <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1BorderPanelOverlayElement.html" title="A specialisation of the PanelOverlayElement to provide a panel with a border.">BorderPanelOverlayElement</a>(instanceName);
<a name="l00092"></a>00092         }
<a name="l00094"></a>00094         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTypeName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00095"></a>00095     };
<a name="l00096"></a>00096 
<a name="l00098"></a><a class="code" href="classOgre_1_1TextAreaOverlayElementFactory.html">00098</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TextAreaOverlayElementFactory.html" title="Factory for creating TextAreaOverlayElement instances.">TextAreaOverlayElementFactory</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1OverlayElementFactory.html" title="Defines the interface which all components wishing to supply OverlayElement subclasses must implement...">OverlayElementFactory</a>
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100     <span class="keyword">public</span>:
<a name="l00102"></a><a class="code" href="classOgre_1_1TextAreaOverlayElementFactory.html#aea75e658e881632cd4c67a38d952af9f">00102</a>         <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* createOverlayElement(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName)
<a name="l00103"></a>00103         {
<a name="l00104"></a>00104             <span class="keywordflow">return</span> <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1TextAreaOverlayElement.html" title="This class implements an overlay element which contains simple unformatted text.">TextAreaOverlayElement</a>(instanceName);
<a name="l00105"></a>00105         }
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTypeName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00108"></a>00108     };
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
